/* do not edit automatically generated by mc from alists.  */
/* alists.def address lists module.

Copyright (C) 2015-2023 Free Software Foundation, Inc.
Contributed by Gaius Mulley <gaius.mulley@southwales.ac.uk>.

This file is part of GNU Modula-2.

GNU Modula-2 is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

GNU Modula-2 is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Modula-2; see the file COPYING3.  If not see
<http://www.gnu.org/licenses/>.  */


#if !defined (_alists_H)
#   define _alists_H

#include "config.h"
#include "system.h"
#   ifdef __cplusplus
extern "C" {
#   endif
#include <stdbool.h>
#   if !defined (PROC_D)
#      define PROC_D
       typedef void (*PROC_t) (void);
       typedef struct { PROC_t proc; } PROC;
#   endif

#   include "GSYSTEM.h"

#   if defined (_alists_C)
#      define EXTERN
#   else
#      define EXTERN extern
#   endif

#if !defined (alists_alist_D)
#  define alists_alist_D
   typedef void *alists_alist;
#endif

typedef struct alists_performOperation_p alists_performOperation;

typedef void (*alists_performOperation_t) (void *);
struct alists_performOperation_p { alists_performOperation_t proc; };


/*
   initList - creates a new alist, l.
*/

EXTERN alists_alist alists_initList (void);

/*
   killList - deletes the complete alist, l.
*/

EXTERN void alists_killList (alists_alist *l);

/*
   putItemIntoList - places an ADDRESS, c, into alist, l.
*/

EXTERN void alists_putItemIntoList (alists_alist l, void * c);

/*
   getItemFromList - retrieves the nth ADDRESS from alist, l.
*/

EXTERN void * alists_getItemFromList (alists_alist l, unsigned int n);

/*
   getIndexOfList - returns the index for ADDRESS, c, in alist, l.
                    If more than one CARDINAL, c, exists the index
                    for the first is returned.
*/

EXTERN unsigned int alists_getIndexOfList (alists_alist l, void * c);

/*
   noOfItemsInList - returns the number of items in alist, l.
*/

EXTERN unsigned int alists_noOfItemsInList (alists_alist l);

/*
   includeItemIntoList - adds an ADDRESS, c, into a alist providing
                         the value does not already exist.
*/

EXTERN void alists_includeItemIntoList (alists_alist l, void * c);

/*
   removeItemFromList - removes an ADDRESS, c, from a alist.
                        It assumes that this value only appears once.
*/

EXTERN void alists_removeItemFromList (alists_alist l, void * c);

/*
   isItemInList - returns true if a ADDRESS, c, was found in alist, l.
*/

EXTERN bool alists_isItemInList (alists_alist l, void * c);

/*
   foreachItemInListDo - calls procedure, P, foreach item in alist, l.
*/

EXTERN void alists_foreachItemInListDo (alists_alist l, alists_performOperation p);

/*
   duplicateList - returns a duplicate alist derived from, l.
*/

EXTERN alists_alist alists_duplicateList (alists_alist l);
#   ifdef __cplusplus
}
#   endif

#   undef EXTERN
#endif
